var db = require('../db');
var ObjectId = require('mongodb').ObjectId;

var collectionName = 'languages';

module.exports = {
  all: function(callback) {
    db.get().collection(collectionName).find().toArray(callback);
  },
  
  add: function(language, callback) {
    var found = function(err, foundLanguage) {
      if(foundLanguage)
        callback(new Error('duplicate not allowed'));
       else
         db.get().collection(collectionName).insert(language, callback);
    }                                                             
    
    db.get().collection(collectionName).findOne(language, found);
  },
  
  delete: function(languageId, callback) {         
    var handleDelete = function(err, result) {
      if(result.deletedCount !== 1)
        callback(new Error('unable to delete language with id: ' + languageId));
      else
        callback(null);
    } 
    
    db.get().collection(collectionName).deleteOne(
      {_id: new ObjectId(languageId)}, handleDelete);
  }
};