(function(app) {                    
  app.LanguagesService = ng.core
    .Class({
      constructor: [ng.http.Http, function(_http) {
        this.http = _http;
      }],
      get: function() {
        return this.http.get('/languages')
                   .map(this.extractData)
                   .catch(this.returnError);
      },
      extractData: function(response) {
        if(response.status !== 200)
          throw new Error("Error, status: " + response.status);
        
        try {
          return response.json();
        } catch(ex) {
          return response.text();
        }
      },
      returnError: function(error) {
        return Rx.Observable.throw(error.message || "Error: request failed");
      },
      add: function(language) {
        var options = 
          {headers: new ng.http.Headers({'Content-Type': 'application/json'})};
        
        return this.http.post('/languages', JSON.stringify(language), options)
                   .map(this.extractData)
                   .catch(this.returnError);
      },
      delete: function(languageId) {
        return this.http.delete('/languages/' + languageId)
                   .map(this.extractData)
                   .catch(this.returnError);
      }
    });
})(window.app || (window.app = {}));