var http = require('http');
var app = require('../../app');

before(function() {
  var port = process.env.PORT || 3030;

  http.createServer(app).listen(port);
});

beforeEach(function(done) {
   var db = require('../../db');
   var config = require('../../config.json');
   var dburl = config[app.get('env')].dburl;
   
   var callback = function() {
     db.get().collection('languages').remove();
     
     var languages = [
       {name: 'Ruby', author: 'Matz'},
       {name: 'LISP', author: 'John McCarthy'},
     ];
     db.get().collection('languages').insert(languages);
     
     done();
   }
   
  db.connect(dburl, callback);  
});
//END:BEFOREEACH