var fetchModelById = function(modelId) {
  return element(by.id(modelId));
}

var fetchBindingById = function(bindingID) {
  return element(by.id(bindingID));
}

var fetchClickById = function(clickId) {
  return element(by.id(clickId));
}

var sendKey = function(element, text) { 
  text.split('').forEach(function(ch) {
    element.sendKeys(ch);
  });  
}

var LanguagesAPage = function() {
  browser.get('/');
}

LanguagesAPage.prototype = {
  get languagesCount() { 
    return fetchBindingById('length').getText(); 
  },

  get languagesAsText() { 
    return element(by.css('table')).getText();
  },

  get message() { return fetchBindingById('message').getText(); },
  
  deleteAt: function(index) {
    return element.all(by.css('table tr')).get(index)
           .element(by.tagName('A'));
  },
                   
  set name(text) { sendKey(fetchModelById('name'), text); },
  
  set author(text) { sendKey(fetchModelById('author'), text); },

  submit: function() { 
    fetchClickById('submit').click(); 
  },
};

module.exports = LanguagesAPage;