var eventually = require('./eventually');
var LanguagesPage = require('./languages-page');

describe('languages ui test', function() {
  var page;
  
  beforeEach(function() {
    page = new LanguagesPage();
  });
  
  it('page should show correct language count', function() {
    eventually(page.languagesCount).eql('2');
  });
  
  it('page should display languages', function() {
    eventually(page.languagesAsText).contain('Ruby');
    eventually(page.languagesAsText).contain('LISP');
  });
  
  it('should successfully add a language', function() {
    page.name = 'JavaScript';
    page.author = 'Brendan Eich';
    page.submit();
    
    eventually(page.message).contain('language added');
    eventually(page.languagesAsText).contain('JavaScript');
    eventually(page.languagesAsText).contain('Eich');
  });
  
  it('should successfully delete a language', function() {
    page.deleteAt(1).click();

    eventually(page.message).contain('language deleted');
    eventually(page.languagesAsText).not.contain('Ruby');
  });
});
